datablock ItemData(MarimbaItem) {
  category = "Weapon";
  className = "Weapon";

  shapeFile = "./models/marimba_item.dts";
  emap = true;

  uiName = "Marimba";
  iconName = "./icon_marimba";

  image = MarimbaImage;
  canDrop = true;

  doColorShift = false;
  colorShiftColor = "-0.52 0 0.1";

  friction = 0.599218;
};

datablock ShapeBaseImageData(MarimbaImage) {
  className = "WeaponImage";
  shapeFile = "./models/marimba_image.dts";
  item = MarimbaItem;
  emap = true;

  mountPoint = 0;

  offset = "-0.5 0.01 0.16";
  eyeOffset = "0 0.9 -0.5";

  // This is used by the instruments mod to determine what sounds to use
  // It's also used to check if an image is even an instrument to begin with
  instrumentType = "Marimba";

  doColorShift = true;
  colorShiftColor = MarimbaItem.colorShiftColor;

  stateName[0]                     = "Activate";
  stateTimeoutValue[0]             = 0.15;
  stateTransitionOnTimeout[0]       = "Ready";
  stateSound[0]          = weaponSwitchSound;

  stateName[1]                     = "Ready";
  stateTransitionOnTriggerDown[1]  = "Play";
  stateAllowImageChange[1]         = true;
  stateSequence[1]  = "Ready";

  stateName[2]                    = "Play";
  stateTransitionOnTimeout[2]     = "PostPlay";
  stateTimeoutValue[2]            = 0.14;
  stateFire[2]                    = true;
  stateAllowImageChange[2]        = false;
  stateScript[2]                  = "onPlay";
  stateWaitForTimeout[2]      = true;
  stateEmitterTime[2]        = 0.05;

  stateName[3] = "PostPlay";
  stateEmitterTime[3]        = 0.05;
  stateEmitterNode[3]        = "muzzleNode";
  stateTimeoutValue[3]            = 0.01;
  stateTransitionOnTimeout[3]     = "Reload";

  stateName[4]      = "Reload";
  stateSequence[4]                = "Reload";
  stateTransitionOnTriggerUp[4]     = "Ready";
  stateSequence[4]  = "Ready";
};

// ------------------------------------------------------------------------------

function MarimbaImage::onMount(%this, %obj, %slot) {
  Parent::onMount(%this, %obj, %slot);
  %obj.playThread(2, armReadyBoth);
}

function MarimbaImage::onUnmount(%this, %obj, %slot) {
  Parent::onUnmount(%this, %obj, %slot);

  %obj.playThread(2, root);

  if (isObject(%obj.client)) {
    %obj.client.applyBodyParts();
    %obj.client.applyBodyColors();
  }
  else {
    applyDefaultCharacterPrefs(%obj);
  }
}

// ------------------------------------------------------------------------------

function MarimbaImage::onPlay(%this, %obj, %pos) {
  // callback
}
